/* PTMovies	-	Display Panorama Movies
   Copyright (C) 2000 - Helmut Dersch  der@fh-furtwangen.de
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.net.URLConnection;
import java.util.*;
import java.text.*;
import java.io.*;
import java.lang.reflect.*;
import java.lang.*;


public class ptflat extends Applet implements Runnable
{
	String PTViewer = "ptviewer";
	int vx = 0, vy = 0;
	int width, height;
	ptviewer pv = null;
	int idata[] = null, sdata[] = null;
	Thread loadImage = null;
	String filename = "image.jpg";
	MemoryImageSource source = null;
	Image view = null;
	int cizf = -1, cxl = -1, cyt = -1;


	public ptflat(){}


	public ptflat( ptviewer p, String properties ){
		pv = p;
		setStub(new ptstub(pv, properties ));
	}	

	
   	public void init(){
   		String s;
 
		s = getParameter( "PTViewer"); 		if( s!=null )	PTViewer = s;
 		s = getParameter( "file"); 			if( s!=null ) 	filename = s;
		s = getParameter( "vx");			if( s!=null )	vx = Integer.parseInt(s);
		s = getParameter( "vy");			if( s!=null )	vy = Integer.parseInt(s);
		while( pv == null ){		
			try{
				pv = (ptviewer) getAppletContext().getApplet(PTViewer);
			}catch(Exception e){
   				try{ Thread.sleep( 2000 );}				
					catch (InterruptedException ie) {return;}
			}
		}
		
	}
	
	public void start(){
 		if( pv!=null){
       		pv.startCommunicating(this);
			if( loadImage == null ){
				loadImage = new Thread( this );
				loadImage.start();
 			}
		}
   	}
   	
   	public void stop(){
		if( loadImage != null ){
			loadImage.stop();
			loadImage = null;
			if(pv != null )
				pv.stopCommunicating(this);
		}
	}
	
	public void run(){
		if( filename == null ) return;
		
		Image im = pv.loadImage( filename );
		if( im == null ) return;
		
		PixelGrabber pg;
        width  = im.getWidth(null) ;
        height = im.getHeight(null);
        
 		
		try{
			sdata = new int[width*height];
			pg = new PixelGrabber( im, 0, 0, width, height, sdata, 0, width );
        	pg.grabPixels();
        	idata = new int[pv.vwidth*pv.vheight];
           	getView();
     		source = new MemoryImageSource(pv.vwidth, pv.vheight, idata, 0, pv.vwidth); 
        	source.setAnimated(true);
			view = createImage(source);
       		pv.repaint();
       }catch (Exception e){ return;}
        
	}


	// Set pixels in idata[] depending on yaw/pitch/hfov
	// hfov = pv.hfov_max corresponds to 100 %
	
	void getView(){ 
		int x,y,xs,ys,cx,cy,dx,dy,idx;
		int p00,p01, p10, p11;
		double zf = (pv.hfov / pv.hfov_max) * ((double)width)/((double)pv.vwidth);
		double pwidth 	= zf * (double)pv.vwidth;
		double pheight 	= zf * (double)pv.vheight;
		
		double xc = ((pv.yaw 	- pv.yaw_min ) / ( pv.yaw_max - pv.yaw_min )) * (double)width ;
		double yc = ((- pv.pitch 	+  pv.pitch_max) / (pv.pitch_max - pv.pitch_min)) * (double)height ;

		int xl = (int)(xc - pwidth/2.0 + 0.5);
		if( xl < 0 ) xl = 0;
		
		int xr = xl + (int)(pwidth+0.5);
		if( xr >= width ) {
			xr = width-1;
			xl = xr - (int)(pwidth+0.5);
			if( xl < 0 ) xl = 0;
		}
		
		int yt = (int)(yc - pheight/2.0 + 0.5);
		if( yt < 0 ) yt = 0;
		
		int yb = yt + (int)(pheight+0.5);
		if( yb >= height ) {
			yb = height-1;
			yt = yb - (int)(pheight+0.5);
			if(yt < 0 ) yt = 0;
		}
		
		int izf = (int)( 255.0 * zf + 0.5 );
		xl = xl * 255;
		yt = yt * 255;
		
		if(xl== cxl && yt == cyt && cizf == izf) return;
		
		for(y=0; y<pv.vheight; y++){
			cy = y * pv.vwidth;
			for(x=0; x<pv.vwidth; x++){
				cx = cy + x;
				xs = xl +  x * izf;
				dx = xs & 0xff; xs >>= 8;
				ys = yt +  y * izf;
				dy = ys & 0xff; ys >>= 8;
				if( xs >= 0 && xs + 1 < width && ys >= 0 && ys + 1 < height ){
					p00 = sdata[idx = ys * width + xs]; 
					p01 = sdata[idx + 1];
					p10 = sdata[idx = idx + width];
					p11 = sdata[idx + 1];
					idata[cx] = pv.bil(p00, p01, p10, p11, dx, dy);	
				}else{
					idata[cx] = 0xff888888;
				}
			}
		}
		xl = cxl; cyt = yt; cizf = izf;
		if(source!=null) source.newPixels();
	}
				
		
	public void paint(Graphics g){
		if( pv == null ) return;
		
		if( view == null ){
			g.clearRect(pv.vx, pv.vy, pv.vx+pv.vwidth, pv.vy+pv.vheight );
        	g.drawString("Loading Image...", vx + 30, pv.vy+pv.vheight/2);
        }else{
			getView();
			g.drawImage(view, vx + pv.vx, vy + pv.vy, pv);
		}
	}
	
}
