/* PTMovies	-	Display Panorama Movies
   Copyright (C) 2000 - Helmut Dersch  der@fh-furtwangen.de
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.net.URLConnection;
import java.util.*;
import java.text.*;
import java.io.*;
import java.lang.reflect.*;
import java.lang.*;


public class ptmedia extends Applet implements Runnable
{
	Thread sendMovie = null;
	String fname = "file";
	String PTViewer = "ptviewer";
	int vx = 0, vy = 0;
	ptviewer pv = null;
	int loop = 1;
	Object 		JMFplayer = null;				// Player for jmf media file n
    long		JMFStopTime = 0;				// Time when media is over
	static final boolean debugJMF = false;

	public ptmedia(){}


	public ptmedia( ptviewer p, String properties ){
		pv = p;
		setStub(new ptstub(pv, properties ));
	}	
	
   	public void init(){
   		String s;
   		// Get parameters
		s = getParameter( "file"); 			if( s!=null )	fname = s;
		s = getParameter( "PTViewer"); 		if( s!=null )	PTViewer = s;
		s = getParameter( "vx");			if( s!=null )	vx = Integer.parseInt(s);
		s = getParameter( "vy");			if( s!=null )	vy = Integer.parseInt(s);
		s = getParameter( "loop");			if( s!=null )	loop = Integer.parseInt(s);

		// Find Applet ptviewer
  
   		while( pv == null ){		
			try{
				pv = (ptviewer) getAppletContext().getApplet(PTViewer);
			}catch(Exception e){
   				try{ Thread.sleep( 2000 );}				
					catch (InterruptedException ie) {return;}
			}
		}

		InitJMFMedia( fname );
	}
	
	public void start(){
		if( sendMovie == null ){
			sendMovie = new Thread(this);
      		sendMovie.start();
      	}
   	}


   	public synchronized void stop(){
		if( pv != null && sendMovie != null ){
			pv.stopThread( sendMovie );
			sendMovie = null;
			pv.stopCommunicating(this);
		}

  		if(pv != null){
 			StopJMFPlayer();
 		}
   	}

   	public synchronized void destroy(){
   		if(pv != null){
   			CloseJMFPlayer();
   		}
   	}
   			

	void InitJMFMedia( String s ){
		Object mrl = null; // MediaLocator 
		URL url = null;
		String mediaFile;
		Class ml=null;
		
		if(pv==null) return;
		
		try {
	    	url = new URL( pv.getDocumentBase(), s);
	    	mediaFile = url.toExternalForm();
		} catch (MalformedURLException mue) {
			return;
		}
		
		try {
	    	// Create a media locator from the file name
	    	ml = Class.forName("javax.media.MediaLocator");
	    	Constructor MediaLocatorConstructor = ml.getConstructor( new Class[]{ String.class });
	    	mrl = MediaLocatorConstructor.newInstance( new Object[]{ mediaFile });
	    	if (mrl == null){
				return;
			}
		} catch (Exception e){
	    	if( debugJMF )
					System.out.println("MediaLocator Exception " + e.getMessage());
			return;
		}
		
	    // Create an instance of a player for this media
	    try {
	    	Class c = Class.forName("javax.media.Manager");
	    	JMFplayer = c.getMethod("createPlayer", new Class[]{ ml }).invoke( c, new Object[]{ mrl });
			// JMFplayer = (Player)Manager.createPlayer(mrl);
	    } catch (Exception e) {
			JMFplayer = null;
	    	if( debugJMF )
					System.out.println("MediaLocator Exception " + e.getMessage());
			return;
		}
	} 


	public void run(){
		
		if(pv == null) return;

		if( JMFplayer != null ){
			long ct;
			try{
				Class JMFpl = Class.forName("javax.media.Player");
				JMFpl.getMethod("start", null).invoke( JMFplayer, null);
			}catch(Exception e){
				if( debugJMF )
					System.out.println("Exception while starting" + e.getMessage());
				return;
			}
			while( JMFStopTime == 0 ){
				StartJMFPlayer();
				if( JMFStopTime == 0 ){	
					try{ Thread.sleep(200);}				
					catch (InterruptedException e) {return;}
				}
			}
				
			while( (ct = System.currentTimeMillis()) < JMFStopTime ){
				try{ Thread.sleep(JMFStopTime - ct);}				
				catch (InterruptedException e) {return;}
			}
					
			StopJMFPlayer();
		}
	}

	void StartJMFPlayer()
	{
		Component 	visualComponent = null;
		Field theField;
        Integer Realized;
        int realized=0;
		
		if( JMFplayer == null ) return;	
		
		try{
        	Class c = JMFplayer.getClass();
        	theField = c.getField("Realized");
        	Realized = (Integer) theField.get(JMFplayer);
       	 	realized = Realized.intValue();
       	 }catch(Exception e){
       	 	if( debugJMF )
					System.out.println("Realized " + e.getMessage());
			return; 
		}
			
		if( JMFGetPlayerState() >= realized ){
			try{
				Class c = Class.forName("javax.media.Player");
				visualComponent = (Component) c.getMethod("getVisualComponent", null).invoke( JMFplayer, null);
				if (visualComponent != null){
		    		pv.add(visualComponent);
		    		Dimension videoSize = visualComponent.getPreferredSize();
		    		int videoWidth = videoSize.width;
		    		int videoHeight = videoSize.height;
		    		visualComponent.setBounds(vx, vy, videoWidth, videoHeight);
		    	}
			}catch(Exception e){
				if( debugJMF )
					System.out.println("Exception getvisualcomponent" + e.getMessage());
					return;
			}
		    	
		    try{
				Class c = Class.forName("javax.media.Duration");
				Method m =  c.getMethod("getDuration", null);
				Object t = m.invoke( JMFplayer, null );
				theField = c.getField("DURATION_UNBOUNDED");
				Object t1 = theField.get(JMFplayer);
				theField = c.getField("DURATION_UNKNOWN");
				Object t2 = theField.get(JMFplayer);
				if( t == t1 ||  t ==  t2 ){
					JMFStopTime = System.currentTimeMillis() + 24*1000*(long)3600; //Play one day
				}
				else{
					c = t.getClass();
					m = c.getMethod("getSeconds", null);
					Double sec = (Double)m.invoke( t, null );	
					JMFStopTime = System.currentTimeMillis() + (long)( sec.doubleValue() * 1000.0 + 5000);
				}
      		}
        	catch(Exception e)
      		{
				if( debugJMF )
        			System.out.println("Problem using Duration");
        		JMFplayer = null;
				return;
			}
		    	
			if( debugJMF )
				System.out.println("Start at " + System.currentTimeMillis() + 
									  "Finish at " + JMFStopTime);
			return;
		}
		else
			return;
	}
	
	void StopJMFPlayer()
	{
	    Component 	visualComponent = null;
		Class JMFController = null, JMFClock = null;
		Field theField;
        Integer Realized;
        int realized=0;
		
		if( JMFplayer == null ) return;	
		
		try{
        	Class c = JMFplayer.getClass();
        	theField = c.getField("Realized");
        	Realized = (Integer) theField.get(JMFplayer);
       	 	realized = Realized.intValue();
       	 }catch(Exception e){
       	 	if( debugJMF )
					System.out.println("Realized " + e.getMessage());
			return; 
		}
			
		
		// Return if player unrealized
    	if( JMFGetPlayerState() < realized ) return;

		
		try{
			JMFController= Class.forName("javax.media.Controller");
      	}
        catch(Exception e){
        	if( debugJMF )
					System.out.println("0:Exception " + e.getMessage());
		}


		if( JMFplayer == null || JMFController == null)
			return;
			
		try{
			Class JMFpl = Class.forName("javax.media.Player");
			visualComponent = (Component) JMFpl.getMethod("getVisualComponent", null).invoke( JMFplayer, null);
			if (visualComponent != null) pv.remove( visualComponent );
      		JMFController.getMethod("stop", null).invoke( JMFplayer, null );
		}catch(Exception e){
				if( debugJMF )
					System.out.println("1:Exception " + e.getMessage());
					return;
		}

   		JMFStopTime = 0;
  		
   		
  		try{
            Object[] longArgs = new Object[] {new Long(0)};
   			Class[] longArgsClass = new Class[] {long.class};
   			Constructor longArgsConstructor = Class.forName("javax.media.Time").getConstructor(longArgsClass);
    		JMFClock= Class.forName("javax.media.Clock");
    		Method m = JMFClock.getMethod("setMediaTime", new Class[]{Class.forName("javax.media.Time")} );
    		m.invoke( JMFplayer, new Object[]{ longArgsConstructor.newInstance( longArgs ) } );
    	}
        catch(Exception e){
        	if( debugJMF )
					System.out.println("2:Exception " + e.getMessage());
		}
	}
	
	void CloseJMFPlayer()
	{
		Class JMFController = null;

		
		try{
			JMFController= Class.forName("javax.media.Controller");
      	}
        catch(Exception e){ return; }


		if( JMFplayer == null || JMFController == null)
			return;
		
		StopJMFPlayer();
       	
       	try{
        	JMFController.getMethod("deallocate", null).invoke( JMFplayer, null );
      		JMFController.getMethod("close", null).invoke( JMFplayer, null );
		}catch(Exception e) {}		

		JMFplayer = null;
	}
		
	int JMFGetPlayerState( )
	{
		Class JMFController = null;
		Method m;
		Integer iobject;
		int a = 0;

		try{
			JMFController= Class.forName("javax.media.Controller");
      	}
        catch(Exception e){}

		if( JMFplayer == null || JMFController == null )
			return -1;
		
			
		try{
			m = JMFController.getMethod("getState", null);
			
			try{
				iobject = ( Integer )m.invoke( JMFplayer, null ); 
				a = iobject.intValue();
			} catch(Exception  e){
				if( debugJMF )
					System.out.println("Invoke Exception " + e.getMessage());
				JMFplayer = null;
				return -1;
			}
		}
		catch(Exception  e){
			if( debugJMF )
				System.out.println("GetMethod Exception " + e.getMessage());
			JMFplayer = null;
			return -1;
		}
		return a;
	}

}
