/* PTMovies	-	Display Panorama Movies
   Copyright (C) 2000 - Helmut Dersch  der@fh-furtwangen.de
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*------------------------------------------------------------*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.net.URLConnection;
import java.util.*;
import java.text.*;
import java.io.*;
import java.lang.reflect.*;
import java.lang.*;


public class ptobject extends Applet implements Runnable
{
	String PTViewer = "ptviewer";
	int vx = 0, vy = 0;
	int nhor = 24, nver = 1;
	ptviewer pv = null;
	int cnv = -1, cnh = -1;
	Image frame[] = null;
	int idata[][] = null;
	MemoryImageSource source[] = null;
	int width, height;
	Thread loadImages = null;
	String filename = "image";
	String maskname = null;
	int showSHS = -1; // Show this hotspot after download is finished
	boolean ready = false;

	public ptobject(){}


	public ptobject( ptviewer p, String properties ){
		pv = p;
		setStub(new ptstub(pv, properties ));
	}	

	public ptobject( ptviewer p, Image[] im, String properties ){
		pv = p;
		frame = im;
		setStub(new ptstub(pv, properties ));
	}	

	
   	public void init(){
   		String s;
 
		s = getParameter( "PTViewer"); 		if( s!=null )	PTViewer = s;
 		s = getParameter( "file"); 			if( s!=null ) 	filename = s;
		s = getParameter( "mask"); 			if( s!=null ) 	maskname = s;
		s = getParameter( "nhor");			if( s!=null )	nhor = Integer.parseInt(s);
		s = getParameter( "nver");			if( s!=null )	nver = Integer.parseInt(s);
		s = getParameter( "vx");			if( s!=null )	vx = Integer.parseInt(s);
		s = getParameter( "vy");			if( s!=null )	vy = Integer.parseInt(s);
		s = getParameter( "showSHS"); 		if( s!=null )	showSHS  = Integer.parseInt(s);
		
		if( frame == null ){
			frame = new Image[nhor * nver];
			idata = new int[nhor * nver][];
			source = new MemoryImageSource[nhor * nver];
		
			for(int i=0; i<nhor * nver; i++) frame[i] = null;
		}
		
		
	}
	
	public void start(){
		while( pv == null ){		
			try{
				pv = (ptviewer) getAppletContext().getApplet(PTViewer);
			}catch(Exception e){
   				try{ Thread.sleep( 2000 );}				
					catch (InterruptedException ie) {return;}
			}
		}

 		if( pv!=null){
 			pv.startCommunicating(this);
 			pv.pan_steps = (pv.hfov/(pv.yaw_max-pv.yaw_min)) * (double)nhor;
 			pv.yaw -= (pv.yaw_max-pv.yaw_min) / (2.0 * (double)nhor);
 			if( frame[0] == null ){
				if( loadImages == null ){
					loadImages = new Thread( this );
					loadImages.start();
				}
			}else{ // We're all set
        		ready = true; // for ptmviewer
        		pv.dirty = true;
        		pv.repaint();
			}	
		}
   	}
   	
   	public void stop(){
		if( pv != null ){
			if( loadImages != null ){
				pv.stopThread( loadImages );
				loadImages = null;
			}
       		if( showSHS >= 0 && showSHS < pv.numshs ){
        		pv.shs_imode[showSHS] = pv.IMODE_NORMAL;
        	}
			pv.stopCommunicating(this);
		}
	}
	


	
	public void run(){
		int i,k;
		
		for( i=nver/2,k=nver/2-1; i<nver; i++,k--){
			loadStripe(i);
			if(pv!=null){
				pv.dirty = true;
			 	pv.repaint();
			}

			if(k>=0){
				loadStripe(k);
				if(pv!=null) {
					pv.dirty = true;
         			pv.repaint();
				}
			}
		}
		if( pv!=null && showSHS >=0 && showSHS<pv.numshs ){
        	pv.shs_imode[showSHS] = pv.IMODE_ALWAYS;
        	pv.repaint();
        }
	}
	
	void loadStripe(int i){
		if(pv==null) return;
		
		String fname;
		int k;
		
		if( nver == 1 ){
			fname = filename;
		}else{
			k = filename.indexOf('#');
			if( k >= 0 ){
				fname = filename.substring( 0, k ) + i + filename.substring( k+1 );
			}else{
				fname = filename + i;
			}
		}
		
		Image im = pv.loadImage(fname);
		
		if(im == null) return;

		PixelGrabber pg;
        width  = im.getWidth(null) / nhor;
        height = im.getHeight(null);
		
		for(k=0; k<nhor; k++){
			try{
				idata[i*nhor + k] = new int[width*height];
				pg = new PixelGrabber( im, k*width, 0, width, height, idata[i*nhor+k], 0, width );
        		pg.grabPixels();
         		source[i*nhor+k] = new MemoryImageSource(width, height, idata[i*nhor+k], 0, width); 
        		source[i*nhor+k].setAnimated(true);
				frame[i*nhor+k] = createImage(source[i*nhor+k]);
       	}catch (Exception e){ 
        			return ; 
        	}
        }
        
         
        if(maskname==null) return;
        
        im = null;
        
        if( nver == 1 ){
			fname = maskname;
		}else{
			k = maskname.indexOf('#');
			if( k >= 0 ){
				fname = maskname.substring( 0, k ) + i + maskname.substring( k+1 );
			}else{
				fname = maskname + i;
			}
		}

        im = pv.loadImage(fname);
        
        if(im == null || im.getWidth(null) / nhor != width || im.getHeight(null) != height) return;
  
   		int[] mdata = new int[width * height];
 		
		
 		for(k=0; k<nhor; k++){
			try{
				pg = new PixelGrabber( im, k*width, 0, width, height, mdata, 0, width );
        		pg.grabPixels(); 
				SetMask( mdata, i*nhor+k, width, height);
        	}catch (Exception e){ 
        		return ; 
        	}
        }
  	}
		
		
			
			
		
   		


	public void paint(Graphics g){
		if( pv == null ) return;
 		
		int nv = (int)((pv.pitch - pv.pitch_min)/(pv.pitch_max - pv.pitch_min)*(double)nver);
		if(nv >=nver) nv = nver-1;
		if(nv < 0) nv = 0;
		
		int nh = (int)((pv.yaw_max - pv.yaw)/(pv.yaw_max - pv.yaw_min)*(double)nhor);
		if(nh >=nhor) nh = nhor-1;
		if(nh < 0) nh = 0;

		if( frame[nv*nhor+nh] == null )
			return;
		
		g.drawImage(frame[nv*nhor+nh], vx + pv.vx, vy + pv.vy,pv);
		
	}
	

 	
 			  
 	void SetMask(int m[], int n, int width, int height){
 		 		
     	int x,y,cy,cx;
       	for(y=0; y<height; y++){
      		cy=y*width;
        	for(x=0; x<width; x++){
        		cx=cy+x;
        		if( (m[cx] & 0xff) != 0xff )
        			idata[n][cx] = 0;
        	}
        }
		source[n].newPixels();
    }    


}
