/* PTViewer	-	Interactive Viewer for Panoramic Images
   Copyright (C) 2000 - Helmut Dersch  der@fh-furtwangen.de
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */ 

/*------------------------------------------------------------*/

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;
import java.text.*;
import java.io.*;
import java.applet.AppletStub;
import java.io.File;
import java.lang.*;




public class ptstub implements AppletStub {
	private Hashtable 		_properties;
	private String 			_sproperties;
 	private Applet 			_applet=null;
 	private ptviewer 		_ptviewer=null;
	private AppletContext 	_context = null;
 	private String 			_path = null;
	
	public ptstub ( ptviewer p, String s ) {
		_ptviewer = p;
		_sproperties = s;
	}

	public ptstub ( Applet a, Frame frame) {
		_applet = a;
		_properties = new Hashtable();
		_context = new ptcontext( frame );
	}

/*	public ptstub ( String fname, Applet a, Frame frame) {
		_applet = a;*/
	public ptstub ( String fname, Frame frame) {
		_properties = new Hashtable();
		_context = new ptcontext( frame );
					
		// Check resources first
			
		try{
			String rname = fname;
			int i = fname.lastIndexOf( File.separatorChar );
			if( i>= 0 )
				rname = fname.substring( i + 1 );
			Class c = Class.forName("ptviewer");
			URL url = c.getResource( rname );
			_path = System.getProperty("user.dir");
			if( rname.toLowerCase().endsWith(".jpeg") 
				|| rname.toLowerCase().endsWith(".jpg")
				|| rname.toLowerCase().endsWith(".jpa")
				|| rname.toLowerCase().endsWith(".jpb")
				|| rname.toLowerCase().endsWith(".jpc") 
		 		|| rname.toLowerCase().endsWith(".mov") ){
				_properties.put ("file", rname );
				return;
			}
			InputStream is = c.getResourceAsStream( rname );
			byte[] readBuffer = readFile( is, 0 );
			is.close();
			ParseHTML( new String(readBuffer) );
			return;
		}catch(Exception e){};
		
		// Try file
		
		File f = new File( fname );
		
		if( !f.exists() ){
 			FileDialog fd = new FileDialog(frame, "Load Panorama...");
			fd.show();
			fname = fd.getFile() ;
			if( fname != null ) 
				f = new File( fd.getDirectory() + fname );
			else
				System.exit(0);
			fd = null;
		}
		
		if( !f.exists() )
				System.exit(0);

		try{
			_path = (new File( f.getCanonicalPath())).getParent();
		}catch(Exception e){}


		if( f.getName().toLowerCase().endsWith(".jpeg") 
		 || f.getName().toLowerCase().endsWith(".jpg")
		 || f.getName().toLowerCase().endsWith(".jpa")
		 || f.getName().toLowerCase().endsWith(".jpb")
		 || f.getName().toLowerCase().endsWith(".jpc") 
		 || f.getName().toLowerCase().endsWith(".mov")){
			_properties.put ("file", f.getName() );
		}else{
			try{
				FileReader fr = new FileReader(f);
				char[] cbuf = new char[(int)f.length()];
				fr.read( cbuf, 0, (int)f.length());
				fr.close();
				ParseHTML( new String(cbuf) );
			}catch(Exception e){ System.exit(0); }
		}
  	}
	
	
	public void appletResize (int width, int height) {
		if(_applet != null)
			_applet.resize (width, height);
 	}

	public AppletContext getAppletContext () {
 		return _context;
	}

	public java.net.URL getCodeBase() { 
		if(_ptviewer != null)
			return _ptviewer.getCodeBase();                          
		java.net.URL u  = null;
		try {
			String path = "file:" + _path ;//System.getProperty("user.dir");
			StringBuffer b = new StringBuffer();
			int i;
			
			for( i = 0; i < path.length(); i++){
				if( path.charAt(i) != ' ' )
					b.append( path.charAt(i) );
				else
					b.append("%20");
			}
			b.append("/");

			u = new java.net.URL (b.toString());

		} catch (Exception e) { }
		 return u;
 	}

	public java.net.URL getDocumentBase() {
		if(_ptviewer != null)
			return _ptviewer.getDocumentBase();                          
		return getCodeBase();
	}

	public String getParameter (String p) {
		if( _ptviewer == null )
			return (String)_properties.get (p);
		else
			return _ptviewer.myGetParameter( _sproperties, p );
	}
	
	public boolean isActive () {
		return true;
	}
	
	private void ParseHTML( String t ){
		int i = 0,j,k = 0;
		String value = null;
		String key = null;
		int m=0;
		String a_tag = null;
		
		// Find applet tag 'a_tag'
		i = 0;		
		while( i < t.length()  && a_tag == null ){
			if( t.regionMatches(true, i, "<applet", 0, 7) ){
				i+=7;
				for(k=i; k<t.length() && t.charAt(k) != '>'; k++);
				a_tag = t.substring(i, k);
			}else
				i++;
		}
		// System.out.println("Found a_tag " + a_tag);
		
		if( a_tag == null  ) return;
		
		// Parse applet tag
				
		j = 0;
		while(j<a_tag.length()){
			while( Character.isWhitespace(a_tag.charAt(j)) && j<a_tag.length() ) j++;

			if(j<a_tag.length()){
				key = a_tag.substring( j, a_tag.substring(j).indexOf('=') + j);
				j += a_tag.substring(j).indexOf('=') + 1;
				if( a_tag.charAt(j) == '"' ){
					j++;
					value = a_tag.substring( j, a_tag.substring(j).indexOf('"') + j);
					j += a_tag.substring(j).indexOf('"') +1;
				}else{
					i = a_tag.substring(j).indexOf(' ');
					if( i >= 0 ){
						value = a_tag.substring( j, i + j);
						j += i +1;
					}else{
						value = a_tag.substring( j );
						j = a_tag.length();
					}
				}
				_properties.put (key, value);
				// System.out.println("found key = " + key + "  and value = " + value);
			}
		}
		
		
		String p_tags = null;

		i = ++k;
		
		while( k < t.length() && p_tags == null ){
			if( t.regionMatches(true, k, "</applet>", 0, 9) ){
				p_tags = t.substring(i, k);
			}else
				k++;
		}
		if( p_tags == null ) return;	
		
		j = 0;
		String p_tag = null;
		while(j<p_tags.length()){
			while( j < p_tags.length() && !p_tags.regionMatches(true, j, "<param", 0, 6) ) j++;
			if(j >= p_tags.length()) return;
			j+=6;

			for(k=j; k<p_tags.length() && p_tags.charAt(k) != '>'; k++);
			if(p_tags.charAt(k) == '>'){
				p_tag = p_tags.substring(j, k);
				j=k+1;
			}else
				return;
			
			i=0;	
			while( i < p_tag.length() && !p_tag.regionMatches(true, i, "name=", 0, 5) ) i++;
			if(i >= p_tag.length()){
				System.out.println("Error in parameter tag: " + p_tag + "  No name tag");
				return;
			}
			i+=5;
			
			k = i;
			while( i < p_tag.length() && ! Character.isWhitespace(p_tag.charAt(i)) ) i++;
			if(i >= p_tag.length()) {
				System.out.println("Error in parameter tag: " + p_tag + "  No value tag");
				return;
			}
			key = p_tag.substring( k, i );
			
			while( i < p_tag.length() && !p_tag.regionMatches(true, i, "value=", 0, 6) ) i++;
			if(i >= p_tag.length()) {
				System.out.println("Error in parameter tag: " + p_tag + "  No value tag");
				return;
			}
			i+=6;

			if( p_tag.charAt(i) == '"' ){
				i++;
				value = p_tag.substring( i, p_tag.substring(i).indexOf('"') + i);
				i += p_tag.substring(i).indexOf('"') +1;
			}else{
				k = p_tag.substring(i).indexOf(' ');
				if( k >= 0 ){
					value = p_tag.substring( i, k + i);
				}else{
					value = p_tag.substring( i );
				}
			}
			_properties.put (key, value);
				// System.out.println("found key = " + key + "  and value = " + value);
		}
	}
	
	byte[] readFile( InputStream is, int fsize ){
		int np = 0, nb = 0, n = 0;
		int bufsize = (fsize > 0 ? fsize/10 + 1 : 50000);
		byte[] buf = new byte[fsize > 0 ? fsize : 50000];
		
		try{
			while( n != -1 ){
				nb = 0;
				if( buf.length < np + bufsize ){
					byte[] temp = new byte[np + bufsize];
					System.arraycopy(buf,0,temp,0,np);
					buf = temp;
				}
					
				while( nb < bufsize &&  (n = is.read( buf, np, bufsize-nb )) != -1 ){
					nb += n; np += n;
				}
			}
			if( buf.length > np ){ 
				byte[] temp = new byte[np];
				System.arraycopy(buf,0,temp,0,np);
				buf = temp;
			}
		}catch(Exception e){ return null; }
		
		return buf;
	}
					
}
